浏览器标题切换
浏览器标题切换end
把博客园图标替换成自己的图标
把博客园图标替换成自己的图标end

[BZOJ4391][Usaco2015 dec]High Card Low Card dp+set+贪心

Description

Bessie the cow is a huge fan of card games, which is quite surprising, given her lack of opposable thumbs. Unfortunately, none of the other cows in the herd are good opponents. They are so bad, in fact, that they always play in a completely predictable fashion! Nonetheless, it can still be a challenge for Bessie to figure out how to win.

Bessie and her friend Elsie are currently playing a simple card game where they take a deck of 2N cards, conveniently numbered 1…2N, and divide them into N cards for Bessie and N cards for Elsie. The two then play NN rounds, where in each round Bessie and Elsie both play a single card. Initially, the player who plays the highest card earns a point. However, at one point during the game, Bessie can decide to switch the rules so that for the rest of the game, the player who plays the lowest card wins a point. Bessie can choose not to use this option, leaving the entire game in "high card wins" mode, or she can even invoke the option right away, making the entire game follow the "low card wins" rule.

Given that Bessie can predict the order in which Elsie will play her cards, please determine the maximum number of points Bessie can win.

 

奶牛Bessie和Elsie在玩一种卡牌游戏。一共有2N张卡牌,点数分别为1到2N,每头牛都会分到N张卡牌。

游戏一共分为N轮,因为Bessie太聪明了,她甚至可以预测出每回合Elsie会出什么牌。

每轮游戏里,两头牛分别出一张牌,点数大者获胜。

同时,Bessie有一次机会选择了某个时间点,从那个时候开始,每回合点数少者获胜。

Bessie现在想知道,自己最多能获胜多少轮?

 

Input

The first line of input contains the value of N (2≤N≤50,000).

The next N lines contain the cards that Elsie will play in each of the successive rounds of the game. Note that it is easy to determine Bessie's cards from this information.

Output

Output a single line giving the maximum number of points Bessie can score.

Sample Input

4
1
8
4
3

Sample Output

3

HINT

Here, Bessie must have cards 2, 5, and 6, and 7 in her hand, and she can use these to win at most 3 points. For example, she can defeat the 1 card and then switch the rules to "low card wins", after which she can win two more rounds.

Solution

做法:$set+dp+$贪心

首先容易想到一个思路,在点数大能赢的情况下尽量用数偏小的,在点数小能赢的情况下尽量用数偏大的

这个用$set$维护

然后设$f[i]$表示前$i$轮为点数大能赢时能赢的最多次数

$g[i]$表示后面$i~n$轮为点数小能赢时能赢得最多次数

所以答案就是$max(f[i]+g[i+1])$

但是这个贪心好像有个问题,就是你一张牌子,可能在上一轮和这一轮都用过一次

其实是没问题...因为你用了两次这张牌,设它为$x$,那么肯定还有一牌$y$没有用,当$x>y$时,这张$y$就可以在后面用,反之就在前面用

#include <cstdio>
#include <set>

using namespace std ;

#define N 100010

int f[ N ] , g[ N ] ;
int n , a[ N ] ;
bool vis[ N ] ;
set< int > s , t ;

int main() {
    scanf( "%d" , &n ) ;
    for( int i = 1 ; i <= n ; i ++ ) {
        scanf( "%d" , &a[ i ] ) ;
        vis[ a[ i ] ] = 1 ;
    }
    for( int i = 1 ; i <= 2 * n ; i ++ ) {
        if( ! vis[ i ] ) s.insert( i ) , t.insert( -i ) ;
    }
    for( int i = 1 ; i <= n ; i ++ ) {
        set< int > :: iterator it  = s.upper_bound( a[ i ] ) ;
        if( it != s.end() ) f[ i ] = f[ i - 1 ] + 1 , s.erase( *it ) ;
        else f[ i ] = f[ i - 1 ] ;
    }
    for( int i = n ; i ; i -- ) {
        set<int> :: iterator it = t.upper_bound( -a[ i ] ) ;
        if( it != t.end() ) g[ i ] = g[ i + 1 ] + 1 , t.erase( *it ) ;
        else g[ i ] = g[ i + 1 ] ;
    }
    int ans = 0 ;
    for( int i = 0 ; i <= n ; i ++ ) {
        ans = max( ans , f[ i ] + g[ i + 1 ] ) ;
    }
    printf( "%d\n" , ans ) ;
}

 

posted @ 2018-09-28 13:30  henry_y  阅读(367)  评论(0编辑  收藏  举报